---
title: WebSocket.send()
slug: Web/API/WebSocket/send
tags:
  - API
  - Method
  - Reference
  - Web API
  - WebSocket
---
<p>{{APIRef("Web Sockets API")}}</p>

<p>The <strong><code>WebSocket.send()</code></strong> method enqueues the specified data to be transmitted to the server over the WebSocket connection, increasing the value of <code>bufferedAmount</code> by the number of bytes needed to contain the data. If the data can't be sent (for example, because it needs to be buffered but the buffer is full), the socket is closed automatically.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">WebSocket.send("Hello server!");</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>data</code></dt>
 <dd>The data to send to the server. It may be one of the following types:
 <dl>
  <dt>{{domxref("USVString")}}</dt>
  <dd>A text string. The string is added to the buffer in UTF-8 format, and the value of <code>bufferedAmount</code> is increased by the number of bytes required to represent the UTF-8 string.</dd>
  <dt>{{domxref("ArrayBuffer")}}</dt>
  <dd>You can send the underlying binary data used by a typed array object; its binary data contents are queued in the buffer, increasing the value of <code>bufferedAmount</code> by the requisite number of bytes.</dd>
  <dt>{{domxref("Blob")}}</dt>
  <dd>Specifying a <code>Blob</code> enqueues the blob's raw data to be transmitted in a binary frame. The value of <code>bufferedAmount</code> is increased by the byte size of that raw data.</dd>
  <dt>{{domxref("ArrayBufferView")}}</dt>
  <dd>You can send any <a href="/en-US/docs/Web/JavaScript/Typed_arrays">JavaScript typed array</a> object as a binary frame; its binary data contents are queued in the buffer, increasing the value of <code>bufferedAmount</code> by the requisite number of bytes.</dd>
 </dl>
 </dd>
</dl>

<h3 id="Exceptions_thrown">Exceptions thrown</h3>

<dl>
 <dt><code>INVALID_STATE_ERR</code></dt>
 <dd>The connection is not currently <code>OPEN</code>.</dd>
 <dt><code>SYNTAX_ERR</code></dt>
 <dd>The data is a string that has unpaired surrogates.</dd>
</dl>

<div class="note">
<p><strong>Note:</strong> Gecko's implementation of the <code>send()</code> method differs somewhat from the specification in {{Gecko("6.0")}}; Gecko returns a <code>boolean</code> indicating whether or not the connection is still open (and, by extension, that the data was successfully queued or transmitted); this is corrected in {{Gecko("8.0")}}.</p>

<p>As of {{Gecko("11.0")}}, support for {{jsxref("ArrayBuffer")}} is implemented but not {{domxref("Blob")}} data types.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-websocket-send', 'WebSocket: send')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WebSocket.send")}}</p>
